# Class VulkanPipelineShaderStageCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineShaderStageCreateInfo.Builder

Enclosing class:
  `VulkanPipelineShaderStageCreateInfo`

public static final class VulkanPipelineShaderStageCreateInfo.Builder extends Object
Builds instances of type `VulkanPipelineShaderStageCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanPipelineShaderStageCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `addFlags(VulkanPipelineShaderStageCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `addFlags(VulkanPipelineShaderStageCreateFlag... elements)`
  Adds elements to `flags` set.
  `VulkanPipelineShaderStageCreateInfo`
  `build()`
  Builds a new `VulkanPipelineShaderStageCreateInfo`.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `from(VulkanPipelineShaderStageCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanPipelineShaderStageCreateInfoType` instance.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `setFlags(Iterable<VulkanPipelineShaderStageCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `setModule(VulkanShaderModuleType module)`
  Initializes the value for the `module` attribute.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `setShaderEntryPoint(String shaderEntryPoint)`
  Initializes the value for the `shaderEntryPoint` attribute.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `setSpecializationInfo(VulkanSpecializationMap specializationInfo)`
  Initializes the optional value `specializationInfo` to specializationInfo.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `setSpecializationInfo(Optional<? extends VulkanSpecializationMap> specializationInfo)`
  Initializes the optional value `specializationInfo` to specializationInfo.
  `final VulkanPipelineShaderStageCreateInfo.Builder`
  `setStage(VulkanShaderStageFlag stage)`
  Initializes the value for the `stage` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanPipelineShaderStageCreateInfo.Builder from(VulkanPipelineShaderStageCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanPipelineShaderStageCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanPipelineShaderStageCreateInfo.Builder addFlags(VulkanPipelineShaderStageCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanPipelineShaderStageCreateInfo.Builder addFlags(VulkanPipelineShaderStageCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanPipelineShaderStageCreateInfo.Builder setFlags(Iterable<VulkanPipelineShaderStageCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanPipelineShaderStageCreateInfo.Builder addAllFlags(Iterable<VulkanPipelineShaderStageCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setStage

    public final VulkanPipelineShaderStageCreateInfo.Builder setStage(VulkanShaderStageFlag stage)
    Initializes the value for the `stage` attribute.
    Parameters:
      `stage` - The value for stage
    Returns:
      `this` builder for use in a chained invocation

  - ### setModule

    public final VulkanPipelineShaderStageCreateInfo.Builder setModule(VulkanShaderModuleType module)
    Initializes the value for the `module` attribute.
    Parameters:
      `module` - The value for module
    Returns:
      `this` builder for use in a chained invocation

  - ### setShaderEntryPoint

    public final VulkanPipelineShaderStageCreateInfo.Builder setShaderEntryPoint(String shaderEntryPoint)
    Initializes the value for the `shaderEntryPoint` attribute.
    Parameters:
      `shaderEntryPoint` - The value for shaderEntryPoint
    Returns:
      `this` builder for use in a chained invocation

  - ### setSpecializationInfo

    public final VulkanPipelineShaderStageCreateInfo.Builder setSpecializationInfo(VulkanSpecializationMap specializationInfo)
    Initializes the optional value `specializationInfo` to specializationInfo.
    Parameters:
      `specializationInfo` - The value for specializationInfo
    Returns:
      `this` builder for chained invocation

  - ### setSpecializationInfo

    public final VulkanPipelineShaderStageCreateInfo.Builder setSpecializationInfo(Optional<? extends VulkanSpecializationMap> specializationInfo)
    Initializes the optional value `specializationInfo` to specializationInfo.
    Parameters:
      `specializationInfo` - The value for specializationInfo
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanPipelineShaderStageCreateInfo build()
    Builds a new `VulkanPipelineShaderStageCreateInfo`.
    Returns:
      An immutable instance of VulkanPipelineShaderStageCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing